--  quickdb.e
--
--  Extra database routines to make things a bit quicker

include database.e

integer lock_type
    lock_type = DB_LOCK_EXCLUSIVE

global procedure db_lock_type( integer new_type )
    lock_type = new_type
end procedure

global function db_load( sequence path )

    integer ret
    
    -- try select
    ret = db_select( path )
    if ret = DB_OK then
        -- success
        return DB_OK
    end if
    
    -- try open
    ret = db_open( path, lock_type )
    if ret = DB_OK then
        -- success
        return DB_OK
    end if
    
    -- try create
    ret = db_create( path, lock_type )
    if ret = DB_OK then
        -- success
        return DB_OK
    end if
    
    -- failure
    return ret
end function

global function db_load_table( sequence table )

    integer ret
    
    -- try select
    ret = db_select_table( table )
    if ret = DB_OK then
        return DB_OK
    end if
    
    -- try create
    ret = db_create_table( table )
    if ret = DB_OK then
        return DB_OK
    end if
    
    -- failure
    return ret
end function

global function db_auto_insert( object data )

    integer count
    object key
    
    -- default key
    key = 1
    
    -- find last key
    count = db_table_size()
    if count then
        -- set next key
        key = db_record_key( count ) + 1
    end if
    
    -- insert
    return db_insert( key, data )
end function

global procedure db_update( object key, object data )

    integer rec
    
    rec = db_find_key( key )
    if rec > 0 then
        db_replace_data( rec, data )
    else
        rec = db_insert( key, data )
    end if

end procedure

